<?php

//////////
///
///   activity.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_ADMN) {
   $dm['activity.add']            ['function'] = 'activity_add';
//   $dm['activity.add']           ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcString,     // $activity
//                                                             $xmlrpcString,     // $desc
//                                                             $xmlrpcString,     // $contact
//                                                             $xmlrpcString));   // $status
}

if($al & AL_ADMN) {
   $dm['activity.mod']            ['function'] = 'activity_mod';
//   $dm['activity.mod']           ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcString,     // $activity
//                                                             $xmlrpcString,     // $desc
//                                                             $xmlrpcString,     // $contact
//                                                             $xmlrpcString));   // $status
}

if($al & AL_ADMN) {
   $dm['activity.del']            ['function'] = 'activity_del';
//   $dm['activity.del']           ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_VIEW)) {
   $dm['activity.get']            ['function'] = 'activity_get';
//   $dm['activity.get']           ['signature'] = array(array($xmlrpcArray,      // return value
//                                                             $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_VIEW)) {
   $dm['activity.getvalidity']    ['function'] = 'activity_getvalidity';
//   $dm['activity.getvalidity']   ['signature'] = array(array($xmlrpcArray,      // return value
//                                                             $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_VIEW)) {
   $dm['activity.getbackdoor']    ['function'] = 'activity_getbackdoor';
//   $dm['activity.getbackdoor']   ['signature'] = array(array($xmlrpcArray,      // return value
//                                                             $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_VIEW)) {
   $dm['activity.gettarget']    ['function'] = 'activity_gettarget';
}


/***************\
*   FUNCTIONS   *
\***************/

function activity_add($activity, $desc, $contact, $status)
{
   $err_map[1062] = $GLOBALS['err_activity']['exists'];

   $ret = db_escape(array(&$activity,
                          &$desc,
                          &$contact,
                          &$status));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "INSERT INTO `activity` (`activity`, ";
   $sql .=                         "`desc`, ";
   $sql .=                         "`contact`, ";
   $sql .=                         "`status`) ";
   $sql .= "VALUES ('$activity', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$contact', ";
   $sql .=         "'$status')";

   return db_query($sql, $err_map);
}

function activity_mod($activity, $desc, $contact, $status)
{
   $ret = db_escape(array(&$activity,
                          &$desc,
                          &$contact,
                          &$status));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "UPDATE `activity` ";
   $sql .= "SET `desc` = '$desc', ";
   $sql .=     "`contact` = '$contact', ";
   $sql .=     "`status` = '$status' ";
   $sql .= "WHERE `activity` = '$activity'";

   return db_query($sql);
}

function activity_del($activity)
{
   $ret = db_escape(array(&$activity));

   if(is_object($ret)) {
      return $ret;
   }

   $sql = "DELETE FROM `activity` ";
          "WHERE `activity` = '$activity'";

   return db_query($sql);
}

function activity_get($activity)
{
   $ret = db_escape(array(&$activity));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `activity`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`contact`, ";
   $sql .=        "`status` ";
   $sql .= "FROM `activity`";
   $sql .= ($activity ? " WHERE `activity` = '$activity'" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_activity']['empty'];
   }

   return $ret;
}

function activity_getvalidity($activity)
{
   return $GLOBALS['err_activity']['novalidity'];
}

function activity_getbackdoor($activity)
{
   $ret = db_escape(array(&$activity));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`version` ";
   $sql .= "FROM `backdoor` ";
   //$sql .= "WHERE `activity` = '$activity'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_activity']['nobackdoor'];
   }

   foreach($ret as &$r) {
      settype($r->version, 'integer');
   }
   unset($r);

   return $ret;
}

function activity_gettarget($activity_id)
{
   $ret = db_escape(array(&$activity_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `target_id`, ";
   $sql .=        "`target`, ";
   $sql .=        "`desc` ";
   $sql .= "FROM `target` ";
   $sql .= "WHERE `activity_id` = '$activity_id'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_activity']['nobackdoor'];
   }

   foreach($ret as &$r) {
      settype($r->target_id, 'integer');
   }
   unset($r);

   return $ret;
}

?>
